/****************************************************
**
** PICProgrammerShell.CPP
**
****************************************************/

//#include	"PICProgrammerShell.H"
#include	"PICPS.H"
//#include	"PICProgrammer.H"
#include	"PICP.H"
//#include	"PICProgrammerHardwareParallel.H"
#include	"PICPHP.H"
//#include	"PICProgrammerHardwareSerial.H"
#include	"PICPHS.H"

#include <stdio.h>
#include <conio.h>
#include <ctype.h>

int main( void ) 
{
	PICProgrammerClass			programmer;
	PICProgrammerHardwareClass	*hardware = NULL;

	printf( "PIC Programmer\n\n" );

	printf( "Searching for a Tait Parallel Port Programmer ... " );
	hardware = new PICProgrammerHardwareParallelClass();
	if ( !hardware->Found() ) {
		printf( "Not Found\n" );
		delete hardware;
		hardware = NULL;

		printf( "Searching for a LudiPipo Serial Port Programmer ... " );
		hardware = new PICProgrammerHardwareSerialClass();
		if ( !hardware->Found() ) {
			printf( "Not Found\n" );
			delete hardware;
			hardware = NULL;
		}
	}

	if ( hardware == NULL ) {
		return 1;
	}

	programmer.Set_Hardware( hardware );

//	hardware->Debug();

	printf( "Found %s\n\n", hardware->Get_Description() );

	while (1) {
		printf( "\nCommand: P)rogram V)erify R)ead E)rase C)lear D)ump L)oad Q)uit" );
		char ch = toupper( getch() );

		printf( "\n" );
		if (ch == 'P')	programmer.Program();
		if (ch == 'V')	programmer.Verify();
		if (ch == 'R')	programmer.Read();
		if (ch == 'E')	programmer.Erase();
		if (ch == 'C')	programmer.Clear_Memory();
		if (ch == 'D')	programmer.Dump_Memory();
		if (ch == 'L')	programmer.Load_Memory( "test.hex" );
		if (ch == 'Q')	break;
	}

	delete hardware;
	hardware = NULL;

	return 0;
}
